//#include "sqrt_gmpfrxx.h"
#include <complex>
#include <cmath>
#include "gmpfrxx.h"

std::complex<mpfr_class> sqrt(std::complex <mpfr_class> __z)
//complex sqrt(const complex __z)
{
	unsigned long prec;

	mpfr_class __x, __y, __t, __u;

	prec = __z.real().get_prec();
	if(prec < __z.imag().get_prec())
		prec = __z.imag().get_prec();

	__x.set_prec(prec);
	__y.set_prec(prec);
	__t.set_prec(prec);
	__u.set_prec(prec);

	__x = __z.real();
	__y = __z.imag();

	if (__x == 0UL)
	{
		__t = sqrt(abs(__y) / 2UL);
		if(__y < 0UL)
			return std::complex<mpfr_class>(__t, -__t);
		else
			return std::complex<mpfr_class>(__t, __t);
	}
	else
	{
		__t = sqrt(2UL * (std::abs(__z) + abs(__x)));
		__u = __t / 2UL;
		if(__x > 0UL)
			return std::complex<mpfr_class>(__u, __y / __t);
		else
		{
			if(__y < 0UL)
	            return std::complex<mpfr_class>(abs(__y) / __t,  -__u);
			else
				return std::complex<mpfr_class>(abs(__y) / __t,  __u);
		}
	}
};

