#include <iostream>
#include <cmath>
#include "gmpfrxx.h"
#include "relative_error.h"

using namespace std;

int main()
{
	double a, b, x;

	mpfr_class::set_dprec_dec(50);
	mpfr_class ga, gb, gx;

	cout << "a = ";
	cin >> ga;
	cout << "b = ";
	cin >> gb;

	a = ga.get_d();
	b = gb.get_d();

	cout << "linear equation: " << ga << " * x + " << gb << " = 0" << endl;

	if(ga == 0.0)
	{
		cout << "Cannot solve!\n" << endl;
		return -1;
	}

	x = -b / a;
	gx = -gb / ga;

	cout.precision(50);
	cout << "x = " << x << endl;
	cout << "x = " << gx << endl;
	cout.precision(5);
	cout << "Relative Error: " << relative_error(x, gx) << endl;

	return 0;
}
