#include <iostream>
#include <iomanip>
#include <cmath>
#include "gmpfrxx.h"
#include "relative_error.h"

using namespace std;

int main()
{
	double a, b, c;
	double d, sol[2];

	mpfr_class::set_dprec_dec(50);
	mpfr_class ga, gb, gc;
	mpfr_class gd, gsol[2];

	cout << "a = ";
	cin >> ga;
	cout << "b = ";
	cin >> gb;
	cout << "c = ";
	cin >> gc;

	a = ga.get_d();
	b = gb.get_d();
	c = gc.get_d();

	cout << "input equation: ";
	cout << a << " * x^2 + ";
	cout << b << " * x   + ";
	cout << c << " = 0 " << endl;

	d = b * b - 4 * a * c;
	sol[0] = (-b + sqrt(d)) / (2 * a);
	sol[1] = (-b - sqrt(d)) / (2 * a);

	gd = gb * gb - 4 * ga * gc;
	gsol[0] = (-gb + sqrt(gd)) / (2 * ga);
	gsol[1] = (-gb - sqrt(gd)) / (2 * ga);

	cout.precision(50);
	cout << "Solutions: " << sol[0] << ", " << sol[1] << endl;
	cout << "Solutions: " << gsol[0] << ", " << gsol[1] << endl;

	cout.precision(5);
	cout << "Relative Errors in sol[0]: " << relative_error(sol[0], gsol[0]) << endl;
	cout << "Relative Errors in sol[1]: " << relative_error(sol[1], gsol[1]) << endl;

	return 0;
}
